//--------------------------- Counter Client ----------------------------
//                by Carl Paulson      Cognitive Portals
//                 http://members.tripod.com/~SleepyCP/
//                          cpaulson@home.com
//-----------------------------------------------------------------------
//
//  Suggested HTML Input:
/*
      <APPLET code="CounterC.class" width=60 height=15>
          <param name=FONT       value="Helvetica">
          <param name=STYLE      value="1">
          <param name=SIZE       value="14">

          <param name=FileNANE   value="Counter.txt">
          <param name=PORT       value="7676">

          <param name=BG_Color   value="white">
          <param name=FG_Color   value="red">

          <CENTER><FONT SIZE=3>{If you can read this, your browser 
          dosen`t support Java.}</FONT><BR>
          <FONT FACE="Helvetica" COLOR="#FF0000" SIZE=7>I'd like 
          to count you, but I can't.</FONT></CENTER><BR>
      </APPLET>
*/
//-----------------------------------------------------------------------

import java.applet.Applet;
import java.io.*;
import java.net.*;
import java.awt.*;
import java.util.*;

//-----------------------------------------------------------------------

public class CounterC extends Applet {

    int counter;
    private Color colorBG, colorFG;

    //-------------------------------------------------------------------

    public void init() {

        colorBG    = getColorParam("BGcolor", "magenta");
        setBackground(colorBG);
        colorFG    = getColorParam("FGcolor", "black");
        setForeground(colorFG);
        Socket Soc = null;
        try {
            String host = getCodeBase().getHost();
            int port    = getIntParam("PORT", 8080, 1041, 9999);
            Soc         = new Socket(host, port);

            DataInputStream incomming = new DataInputStream(Soc.getInputStream());
            String line = incomming.readLine();
            counter     = Integer.parseInt(line);

        } catch (IOException e) {
            showStatus("Can't read from Socket");
            e.printStackTrace();
        } finally {
            try {
                Soc.close();
            } catch (IOException alreadyClosed) { }
        }
    }

    //-------------------------------------------------------------------

    public void paint(Graphics g) {
        String str = Integer.toString(counter);
        g.drawString( str, 5, size().height );
    }

    //-------------------------------------------------------------------

    public Color getColorParam(String c, String def_C) {

        Color Color1 = Color.lightGray;      // default color
        if (def_C != null) {
            if      (def_C.equalsIgnoreCase("black"))     Color1 = Color.black;
            else if (def_C.equalsIgnoreCase("blue"))      Color1 = Color.blue;
            else if (def_C.equalsIgnoreCase("cyan"))      Color1 = Color.cyan;
            else if (def_C.equalsIgnoreCase("darkGray"))  Color1 = Color.darkGray;
            else if (def_C.equalsIgnoreCase("gray"))      Color1 = Color.gray;
            else if (def_C.equalsIgnoreCase("green"))     Color1 = Color.green;
            else if (def_C.equalsIgnoreCase("lightGray")) Color1 = Color.lightGray;
            else if (def_C.equalsIgnoreCase("magenta"))   Color1 = Color.magenta;
            else if (def_C.equalsIgnoreCase("orange"))    Color1 = Color.orange;
            else if (def_C.equalsIgnoreCase("pink"))      Color1 = Color.pink;
            else if (def_C.equalsIgnoreCase("red"))       Color1 = Color.red;
            else if (def_C.equalsIgnoreCase("white"))     Color1 = Color.white;
            else if (def_C.equalsIgnoreCase("yellow"))    Color1 = Color.yellow;
        }

        StringTokenizer st;
        String rgbDelim = ":,.";
        String c_str = getParameter(c);
        if (c_str != null) st = new StringTokenizer(c_str, rgbDelim);
        else return Color1;

        if      (c_str.equalsIgnoreCase("black"))     return Color.black;
        else if (c_str.equalsIgnoreCase("blue"))      return Color.blue;
        else if (c_str.equalsIgnoreCase("cyan"))      return Color.cyan;
        else if (c_str.equalsIgnoreCase("darkGray"))  return Color.darkGray;
        else if (c_str.equalsIgnoreCase("gray"))      return Color.gray;
        else if (c_str.equalsIgnoreCase("green"))     return Color.green;
        else if (c_str.equalsIgnoreCase("lightGray")) return Color.lightGray;
        else if (c_str.equalsIgnoreCase("magenta"))   return Color.magenta;
        else if (c_str.equalsIgnoreCase("orange"))    return Color.orange;
        else if (c_str.equalsIgnoreCase("pink"))      return Color.pink;
        else if (c_str.equalsIgnoreCase("red"))       return Color.red;
        else if (c_str.equalsIgnoreCase("white"))     return Color.white;
        else if (c_str.equalsIgnoreCase("yellow"))    return Color.yellow;

        else if (st.countTokens() == 3) {
            Integer r = new Integer(st.nextToken());
            Integer g = new Integer(st.nextToken());
            Integer b = new Integer(st.nextToken());
            Color1    = new Color(r.intValue(), g.intValue(), b.intValue());
            return Color1;
            }
        return Color1;
    }

    //-------------------------------------------------------------------

    public String getStringParam(String x, String def_X) {
        String str;
        str = getParameter(x);
        if (str == null) str = def_X;
        return str;
    }

    //-------------------------------------------------------------------

    public int getIntParam(String i, int def_I, int min_i, int max_i) {
        int i_in;
        try {
            i_in = Integer.parseInt(getParameter(i));
            if ((i_in < min_i)||(i_in > max_i)) throw new Exception();
        } catch (Exception e) {
            System.out.println(i+" invalid; using default value: "+def_I);
            i_in = def_I;
        }	
        return i_in;
    }

    //-------------------------------------------------------------------

    public Font getFontParam(String fnt, String def_Fnt, 
            String Style, int def_Style, String Size, int def_Size) {

        String font_Name  = getStringParam(fnt,   def_Fnt);
        int    font_Style = getIntParam   (Style, def_Style, 0, 3);
        int    font_Size  = getIntParam   (Size,  def_Size, 4, 100);

        return (new Font(font_Name, font_Style, font_Size));
    }

   //-------------------------------------------------------------------

}

// ======================================================================
